variables:
  CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH

stages:
  - build
  - publish

build:
  stage: build
  image: golang:alpine
  before_script:
    # Create a symbolic link under $GOPATH, this is needed for local build
    # i.e. /go/src/gitlab.com/ykyuen/gitlab-ci-go-build
    - cd $GOPATH/src
    - mkdir -p gitlab.com/$CI_PROJECT_NAMESPACE
    - cd gitlab.com/$CI_PROJECT_NAMESPACE
    - ln -s $CI_PROJECT_DIR
    - cd $CI_PROJECT_NAME
  tags:
    - node
  artifacts:
    paths:
      - k8-proxy
    expire_in: 2 days
    when: on_success
  script:
    # Compile and name the binary as `hello`
    - apk add --no-cache git
    - go get ./...
    - go build -o k8-proxy

publish-docker:
  image: docker:stable
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  stage: publish
  only:
    - master
    - develop
  tags:
    - docker
  dependencies:
    - build
  script:
    - docker pull $CONTAINER_IMAGE:latest || true
    - docker build --cache-from $CONTAINER_IMAGE:latest --tag $CONTAINER_IMAGE:$CI_COMMIT_SHA --tag $CONTAINER_IMAGE:latest .
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_SHA
    - docker push $CONTAINER_IMAGE:latest